package cn.estsh.i3plus.ext.mes.apiservice.serviceimpl.base;

import cn.estsh.i3plus.ext.mes.api.base.IMesStationService;
import cn.estsh.i3plus.ext.mes.apiservice.utils.MesException;
import cn.estsh.i3plus.pojo.base.bean.DdlPackBean;
import cn.estsh.i3plus.pojo.base.tool.DdlPreparedPack;
import cn.estsh.i3plus.pojo.mes.bean.MesStation;
import cn.estsh.impp.framework.boot.util.ValidatorBean;
import lombok.extern.slf4j.Slf4j;
import org.springframework.stereotype.Service;

/**
 * @Description :
 * @Reference :
 * @Author : PZJ
 * @CreateDate : 2024/9/20 14:46
 * @Modify:
 **/
@Service
@Slf4j
public class MesStationServiceImpl extends BaseMesService<MesStation> implements IMesStationService {


    @Override
    protected void onInsertBean(MesStation item) {
        ValidatorBean.checkNotNull(item.getEquipmentCode(),"设备代码不能为空");
        DdlPackBean ddlPackBean = DdlPackBean.getDdlPackBean(item.getOrganizeCode());
        DdlPreparedPack.getStringEqualPack(item.getEquipmentCode(),"equipmentCode",ddlPackBean);
        if (baseRDao.isExitByHql(ddlPackBean)){
            MesException.throwBusiException("设备代码已存在");
        }
    }

    @Override
    protected void onUpdateBean(MesStation item) {
        ValidatorBean.checkNotNull(item.getId(),"主键不能为空");
        ValidatorBean.checkNotNull(item.getEquipmentCode(),"设备代码不能为空");
        DdlPackBean ddlPackBean = DdlPackBean.getDdlPackBean(item.getOrganizeCode());
        DdlPreparedPack.getStringEqualPack(item.getEquipmentCode(),"equipmentCode",ddlPackBean);
        DdlPreparedPack.getNumNOEqualPack(item.getId(),"id",ddlPackBean);
        if (baseRDao.isExitByHql(ddlPackBean)){
            MesException.throwBusiException("设备代码已存在");
        }
    }
}
